diff --git a/tests/unit/modules/test_virt.py b/tests/unit/modules/test_virt.py
index 3e9bd5ef49..d3988464f6 100644
--- a/tests/unit/modules/test_virt.py
+++ b/tests/unit/modules/test_virt.py
@@ -2811,95 +4177,143 @@ class VirtTestCase(TestCase, LoaderModuleMockMixin):
       <group>0</group>
     </permissions>
   </target>
-</pool>'''
+</pool>"""
             pool_mocks.append(pool_mock)
         self.mock_conn.listAllStoragePools.return_value = pool_mocks
         # pylint: enable=no-member
 
         pool = virt.pool_info()
-        self.assertEqual({
-            'pool0':
+        self.assertEqual(
             {
-                'uuid': 'some-uuid-0',
-                'state': 'inactive',
-                'capacity': 1234,
-                'allocation': 5678,
-                'free': 123,
-                'autostart': True,
-                'persistent': True,
-                'type': 'dir',
-                'target_path': '/srv/vms'
-            }, 'pool1': {
-                'uuid': 'some-uuid-1',
-                'state': 'inactive',
-                'capacity': 1234,
-                'allocation': 5678,
-                'free': 123,
-                'autostart': True,
-                'persistent': True,
-                'type': 'dir',
-                'target_path': '/srv/vms'
-            }
-        }, pool)
+                "pool0": {
+                    "uuid": "some-uuid-0",
+                    "state": "inactive",
+                    "capacity": 1234,
+                    "allocation": 5678,
+                    "free": 123,
+                    "autostart": True,
+                    "persistent": True,
+                    "type": "dir",
+                    "target_path": "/srv/vms",
+                },
+                "pool1": {
+                    "uuid": "some-uuid-1",
+                    "state": "inactive",
+                    "capacity": 1234,
+                    "allocation": 5678,
+                    "free": 123,
+                    "autostart": True,
+                    "persistent": True,
+                    "type": "dir",
+                    "target_path": "/srv/vms",
+                },
+            },
+            pool,
+        )
 
     def test_pool_get_xml(self):
-        '''
+        """
         Test virt.pool_get_xml
-        '''
+        """
         pool_mock = MagicMock()
-        pool_mock.XMLDesc.return_value = '<pool>Raw XML</pool>'
+        pool_mock.XMLDesc.return_value = "<pool>Raw XML</pool>"
         self.mock_conn.storagePoolLookupByName.return_value = pool_mock
 
-        self.assertEqual('<pool>Raw XML</pool>', virt.pool_get_xml('default'))
+        self.assertEqual("<pool>Raw XML</pool>", virt.pool_get_xml("default"))
 
     def test_pool_list_volumes(self):
-        '''
+        """
         Test virt.pool_list_volumes
-        '''
-        names = ['volume1', 'volume2']
+        """
+        names = ["volume1", "volume2"]
         mock_pool = MagicMock()
         # pylint: disable=no-member
         mock_pool.listVolumes.return_value = names
         self.mock_conn.storagePoolLookupByName.return_value = mock_pool
         # pylint: enable=no-member
-        self.assertEqual(names, virt.pool_list_volumes('default'))
+        self.assertEqual(names, virt.pool_list_volumes("default"))
 
-    @patch('salt.modules.virt._is_kvm_hyper', return_value=True)
-    @patch('salt.modules.virt._is_xen_hyper', return_value=False)
-    def test_get_hypervisor(self, isxen_mock, iskvm_mock):
-        '''
+    @patch("salt.modules.virt._is_bhyve_hyper", return_value=False)
+    @patch("salt.modules.virt._is_kvm_hyper", return_value=True)
+    @patch("salt.modules.virt._is_xen_hyper", return_value=False)
+    def test_get_hypervisor(self, isxen_mock, iskvm_mock, is_bhyve_mock):
+        """
         test the virt.get_hypervisor() function
-        '''
-        self.assertEqual('kvm', virt.get_hypervisor())
+        """
+        self.assertEqual("kvm", virt.get_hypervisor())
 
         iskvm_mock.return_value = False
         self.assertIsNone(virt.get_hypervisor())
 
+        is_bhyve_mock.return_value = False
+        self.assertIsNone(virt.get_hypervisor())
+
         isxen_mock.return_value = True
-        self.assertEqual('xen', virt.get_hypervisor())
+        self.assertEqual("xen", virt.get_hypervisor())
 
     def test_pool_delete(self):
-        '''
+        """
         Test virt.pool_delete function
-        '''
+        """
         mock_pool = MagicMock()
         mock_pool.delete = MagicMock(return_value=0)
+        mock_pool.XMLDesc.return_value = "<pool type='dir'/>"
         self.mock_conn.storagePoolLookupByName = MagicMock(return_value=mock_pool)
 
-        res = virt.pool_delete('test-pool')
+        res = virt.pool_delete("test-pool")
         self.assertTrue(res)
 
-        self.mock_conn.storagePoolLookupByName.assert_called_once_with('test-pool')
+        self.mock_conn.storagePoolLookupByName.assert_called_once_with("test-pool")
 
         # Shouldn't be called with another parameter so far since those are not implemented
         # and thus throwing exceptions.
-        mock_pool.delete.assert_called_once_with(self.mock_libvirt.VIR_STORAGE_POOL_DELETE_NORMAL)
+        mock_pool.delete.assert_called_once_with(
+            self.mock_libvirt.VIR_STORAGE_POOL_DELETE_NORMAL
+        )
+
+    def test_pool_delete_secret(self):
+        """
+        Test virt.pool_delete function where the pool has a secret
+        """
+        mock_pool = MagicMock()
+        mock_pool.delete = MagicMock(return_value=0)
+        mock_pool.XMLDesc.return_value = """
+            <pool type='rbd'>
+              <name>test-ses</name>
+              <source>
+                <host name='myhost'/>
+                <name>libvirt-pool</name>
+                <auth type='ceph' username='libvirt'>
+                  <secret usage='pool_test-ses'/>
+                </auth>
+              </source>
+            </pool>
+        """
+        self.mock_conn.storagePoolLookupByName = MagicMock(return_value=mock_pool)
+        mock_undefine = MagicMock(return_value=0)
+        self.mock_conn.secretLookupByUsage.return_value.undefine = mock_undefine
+
+        res = virt.pool_delete("test-ses")
+        self.assertTrue(res)
+
+        self.mock_conn.storagePoolLookupByName.assert_called_once_with("test-ses")
+
+        # Shouldn't be called with another parameter so far since those are not implemented
+        # and thus throwing exceptions.
+        mock_pool.delete.assert_called_once_with(
+            self.mock_libvirt.VIR_STORAGE_POOL_DELETE_NORMAL
+        )
+
+        self.mock_conn.secretLookupByUsage.assert_called_once_with(
+            self.mock_libvirt.VIR_SECRET_USAGE_TYPE_CEPH, "pool_test-ses"
+        )
+        mock_undefine.assert_called_once()
 
     def test_full_info(self):
-        '''
+        """
         Test virt.full_info
-        '''
-        xml = '''<domain type='kvm' id='7'>
+        """
+        xml = """<domain type='kvm' id='7'>
               <uuid>28deee33-4859-4f23-891c-ee239cffec94</uuid>
               <name>test-vm</name>
               <on_poweroff>destroy</on_poweroff>
@@ -2928,10 +4342,10 @@ class VirtTestCase(TestCase, LoaderModuleMockMixin):
               </graphics>
               </devices>
             </domain>
-        '''
+        """
         self.set_mock_vm("test-vm", xml)
 
-        qemu_infos = '''[{
+        qemu_infos = """[{
             "virtual-size": 25769803776,
             "filename": "/disks/test.qcow2",
             "cluster-size": 65536,
@@ -2966,69 +4380,79 @@ class VirtTestCase(TestCase, LoaderModuleMockMixin):
                 }
             },
             "dirty-flag": false
-        }]'''
+        }]"""
 
-        self.mock_popen.communicate.return_value = [qemu_infos]  # pylint: disable=no-member
+        self.mock_popen.communicate.return_value = [
+            qemu_infos
+        ]  # pylint: disable=no-member
 
-        self.mock_conn.getInfo = MagicMock(return_value=['x86_64', 4096, 8, 2712, 1, 2, 4, 2])
+        self.mock_conn.getInfo = MagicMock(
+            return_value=["x86_64", 4096, 8, 2712, 1, 2, 4, 2]
+        )
 
         actual = virt.full_info()
 
         # Check that qemu-img was called with the proper parameters
-        qemu_img_call = [call for call in self.mock_subprocess.Popen.call_args_list if 'qemu-img' in call[0][0]][0]
-        self.assertIn('info', qemu_img_call[0][0])
-        self.assertIn('-U', qemu_img_call[0][0])
+        qemu_img_call = [
+            call
+            for call in self.mock_subprocess.Popen.call_args_list
+            if "qemu-img" in call[0][0]
+        ][0]
+        self.assertIn("info", qemu_img_call[0][0])
+        self.assertIn("-U", qemu_img_call[0][0])
 
         # Test the hypervisor infos
-        self.assertEqual(2816, actual['freemem'])
-        self.assertEqual(6, actual['freecpu'])
-        self.assertEqual(4, actual['node_info']['cpucores'])
-        self.assertEqual(2712, actual['node_info']['cpumhz'])
-        self.assertEqual('x86_64', actual['node_info']['cpumodel'])
-        self.assertEqual(8, actual['node_info']['cpus'])
-        self.assertEqual(2, actual['node_info']['cputhreads'])
-        self.assertEqual(1, actual['node_info']['numanodes'])
-        self.assertEqual(4096, actual['node_info']['phymemory'])
-        self.assertEqual(2, actual['node_info']['sockets'])
+        self.assertEqual(2816, actual["freemem"])
+        self.assertEqual(6, actual["freecpu"])
+        self.assertEqual(4, actual["node_info"]["cpucores"])
+        self.assertEqual(2712, actual["node_info"]["cpumhz"])
+        self.assertEqual("x86_64", actual["node_info"]["cpumodel"])
+        self.assertEqual(8, actual["node_info"]["cpus"])
+        self.assertEqual(2, actual["node_info"]["cputhreads"])
+        self.assertEqual(1, actual["node_info"]["numanodes"])
+        self.assertEqual(4096, actual["node_info"]["phymemory"])
+        self.assertEqual(2, actual["node_info"]["sockets"])
 
         # Test the vm_info output:
-        self.assertEqual(2, actual['vm_info']['test-vm']['cpu'])
-        self.assertEqual(1234, actual['vm_info']['test-vm']['cputime'])
-        self.assertEqual(1024 * 1024, actual['vm_info']['test-vm']['mem'])
-        self.assertEqual(2048 * 1024, actual['vm_info']['test-vm']['maxMem'])
-        self.assertEqual('shutdown', actual['vm_info']['test-vm']['state'])
-        self.assertEqual('28deee33-4859-4f23-891c-ee239cffec94', actual['vm_info']['test-vm']['uuid'])
-        self.assertEqual('destroy', actual['vm_info']['test-vm']['on_crash'])
-        self.assertEqual('restart', actual['vm_info']['test-vm']['on_reboot'])
-        self.assertEqual('destroy', actual['vm_info']['test-vm']['on_poweroff'])
+        self.assertEqual(2, actual["vm_info"]["test-vm"]["cpu"])
+        self.assertEqual(1234, actual["vm_info"]["test-vm"]["cputime"])
+        self.assertEqual(1024 * 1024, actual["vm_info"]["test-vm"]["mem"])
+        self.assertEqual(2048 * 1024, actual["vm_info"]["test-vm"]["maxMem"])
+        self.assertEqual("shutdown", actual["vm_info"]["test-vm"]["state"])
+        self.assertEqual(
+            "28deee33-4859-4f23-891c-ee239cffec94", actual["vm_info"]["test-vm"]["uuid"]
+        )
+        self.assertEqual("destroy", actual["vm_info"]["test-vm"]["on_crash"])
+        self.assertEqual("restart", actual["vm_info"]["test-vm"]["on_reboot"])
+        self.assertEqual("destroy", actual["vm_info"]["test-vm"]["on_poweroff"])
 
         # Test the nics
-        nic = actual['vm_info']['test-vm']['nics']['ac:de:48:b6:8b:59']
-        self.assertEqual('bridge', nic['type'])
-        self.assertEqual('ac:de:48:b6:8b:59', nic['mac'])
+        nic = actual["vm_info"]["test-vm"]["nics"]["ac:de:48:b6:8b:59"]
+        self.assertEqual("bridge", nic["type"])
+        self.assertEqual("ac:de:48:b6:8b:59", nic["mac"])
 
         # Test the disks
-        disks = actual['vm_info']['test-vm']['disks']
-        disk = disks.get('vda')
-        self.assertEqual('/disks/test.qcow2', disk['file'])
-        self.assertEqual('disk', disk['type'])
-        self.assertEqual('/disks/mybacking.qcow2', disk['backing file']['file'])
-        cdrom = disks.get('hda')
-        self.assertEqual('/disks/test-cdrom.iso', cdrom['file'])
-        self.assertEqual('cdrom', cdrom['type'])
-        self.assertFalse('backing file' in cdrom.keys())
+        disks = actual["vm_info"]["test-vm"]["disks"]
+        disk = disks.get("vda")
+        self.assertEqual("/disks/test.qcow2", disk["file"])
+        self.assertEqual("disk", disk["type"])
+        self.assertEqual("/disks/mybacking.qcow2", disk["backing file"]["file"])
+        cdrom = disks.get("hda")
+        self.assertEqual("/disks/test-cdrom.iso", cdrom["file"])
+        self.assertEqual("cdrom", cdrom["type"])
+        self.assertFalse("backing file" in cdrom.keys())
 
         # Test the graphics
-        graphics = actual['vm_info']['test-vm']['graphics']
-        self.assertEqual('vnc', graphics['type'])
-        self.assertEqual('5900', graphics['port'])
-        self.assertEqual('0.0.0.0', graphics['listen'])
+        graphics = actual["vm_info"]["test-vm"]["graphics"]
+        self.assertEqual("vnc", graphics["type"])
+        self.assertEqual("5900", graphics["port"])
+        self.assertEqual("0.0.0.0", graphics["listen"])
 
     def test_pool_update(self):
-        '''
+        """
         Test the pool_update function
-        '''
-        current_xml = '''<pool type='dir'>
+        """
+        current_xml = """<pool type='dir'>
           <name>default</name>
           <uuid>20fbe05c-ab40-418a-9afa-136d512f0ede</uuid>
           <capacity unit='bytes'>1999421108224</capacity>
@@ -3044,29 +4468,31 @@ class VirtTestCase(TestCase, LoaderModuleMockMixin):
               <group>100</group>
             </permissions>
           </target>
-        </pool>'''
-
-        expected_xml = '<pool type="netfs">' \
-                       '<name>default</name>' \
-                         '<uuid>20fbe05c-ab40-418a-9afa-136d512f0ede</uuid>' \
-                         '<capacity unit="bytes">1999421108224</capacity>' \
-                         '<allocation unit="bytes">713207042048</allocation>' \
-                         '<available unit="bytes">1286214066176</available>' \
-                         '<target>' \
-                           '<path>/mnt/cifs</path>' \
-                           '<permissions>' \
-                             '<mode>0774</mode>' \
-                             '<owner>1234</owner>' \
-                             '<group>123</group>' \
-                           '</permissions>' \
-                         '</target>' \
-                         '<source>' \
-                           '<dir path="samba_share" />' \
-                           '<host name="one.example.com" />' \
-                           '<host name="two.example.com" />' \
-                           '<format type="cifs" />' \
-                         '</source>' \
-                       '</pool>'
+        </pool>"""
+
+        expected_xml = (
+            '<pool type="netfs">'
+            "<name>default</name>"
+            "<uuid>20fbe05c-ab40-418a-9afa-136d512f0ede</uuid>"
+            '<capacity unit="bytes">1999421108224</capacity>'
+            '<allocation unit="bytes">713207042048</allocation>'
+            '<available unit="bytes">1286214066176</available>'
+            "<target>"
+            "<path>/mnt/cifs</path>"
+            "<permissions>"
+            "<mode>0774</mode>"
+            "<owner>1234</owner>"
+            "<group>123</group>"
+            "</permissions>"
+            "</target>"
+            "<source>"
+            '<dir path="samba_share" />'
+            '<host name="one.example.com" />'
+            '<host name="two.example.com" />'
+            '<format type="cifs" />'
+            "</source>"
+            "</pool>"
+        )
 
         mocked_pool = MagicMock()
         mocked_pool.XMLDesc = MagicMock(return_value=current_xml)
@@ -3074,21 +4500,24 @@ class VirtTestCase(TestCase, LoaderModuleMockMixin):
         self.mock_conn.storagePoolDefineXML = MagicMock()
 
         self.assertTrue(
-            virt.pool_update('default',
-                             'netfs',
-                             target='/mnt/cifs',
-                             permissions={'mode': '0774', 'owner': '1234', 'group': '123'},
-                             source_format='cifs',
-                             source_dir='samba_share',
-                             source_hosts=['one.example.com', 'two.example.com']))
+            virt.pool_update(
+                "default",
+                "netfs",
+                target="/mnt/cifs",
+                permissions={"mode": "0774", "owner": "1234", "group": "123"},
+                source_format="cifs",
+                source_dir="samba_share",
+                source_hosts=["one.example.com", "two.example.com"],
+            )
+        )
         self.mock_conn.storagePoolDefineXML.assert_called_once_with(expected_xml)
 
     def test_pool_update_nochange(self):
-        '''
+        """
         Test the pool_update function when no change is needed
-        '''
+        """
 
-        current_xml = '''<pool type='dir'>
+        current_xml = """<pool type='dir'>
           <name>default</name>
           <uuid>20fbe05c-ab40-418a-9afa-136d512f0ede</uuid>
           <capacity unit='bytes'>1999421108224</capacity>
@@ -3104,7 +4533,7 @@ class VirtTestCase(TestCase, LoaderModuleMockMixin):
               <group>100</group>
             </permissions>
           </target>
-        </pool>'''
+        </pool>"""
 
         mocked_pool = MagicMock()
         mocked_pool.XMLDesc = MagicMock(return_value=current_xml)
@@ -3112,18 +4541,21 @@ class VirtTestCase(TestCase, LoaderModuleMockMixin):
         self.mock_conn.storagePoolDefineXML = MagicMock()
 
         self.assertFalse(
-            virt.pool_update('default',
-                             'dir',
-                             target='/path/to/pool',
-                             permissions={'mode': '0775', 'owner': '0', 'group': '100'},
-                             test=True))
+            virt.pool_update(
+                "default",
+                "dir",
+                target="/path/to/pool",
+                permissions={"mode": "0775", "owner": "0", "group": "100"},
+                test=True,
+            )
+        )
         self.mock_conn.storagePoolDefineXML.assert_not_called()
 
     def test_pool_update_password(self):
-        '''
+        """
         Test the pool_update function, where the password only is changed
-        '''
-        current_xml = '''<pool type='rbd'>
+        """
+        current_xml = """<pool type='rbd'>
           <name>default</name>
           <uuid>20fbe05c-ab40-418a-9afa-136d512f0ede</uuid>
           <capacity unit='bytes'>1999421108224</capacity>
@@ -3137,23 +4569,25 @@ class VirtTestCase(TestCase, LoaderModuleMockMixin):
               <secret uuid='14e9a0f1-8fbf-4097-b816-5b094c182212'/>
             </auth>
           </source>
-        </pool>'''
-
-        expected_xml = '<pool type="rbd">' \
-                       '<name>default</name>' \
-                         '<uuid>20fbe05c-ab40-418a-9afa-136d512f0ede</uuid>' \
-                         '<capacity unit="bytes">1999421108224</capacity>' \
-                         '<allocation unit="bytes">713207042048</allocation>' \
-                         '<available unit="bytes">1286214066176</available>' \
-                         '<source>' \
-                           '<host name="ses4.tf.local" />' \
-                           '<host name="ses5.tf.local" />' \
-                           '<auth type="ceph" username="libvirt">' \
-                             '<secret uuid="14e9a0f1-8fbf-4097-b816-5b094c182212" />' \
-                           '</auth>' \
-                           '<name>iscsi-images</name>' \
-                         '</source>' \
-                       '</pool>'
+        </pool>"""
+
+        expected_xml = (
+            '<pool type="rbd">'
+            "<name>default</name>"
+            "<uuid>20fbe05c-ab40-418a-9afa-136d512f0ede</uuid>"
+            '<capacity unit="bytes">1999421108224</capacity>'
+            '<allocation unit="bytes">713207042048</allocation>'
+            '<available unit="bytes">1286214066176</available>'
+            "<source>"
+            '<host name="ses4.tf.local" />'
+            '<host name="ses5.tf.local" />'
+            '<auth type="ceph" username="libvirt">'
+            '<secret uuid="14e9a0f1-8fbf-4097-b816-5b094c182212" />'
+            "</auth>"
+            "<name>iscsi-images</name>"
+            "</source>"
+            "</pool>"
+        )
 
         mock_secret = MagicMock()
         self.mock_conn.secretLookupByUUIDString = MagicMock(return_value=mock_secret)
@@ -3163,21 +4597,23 @@ class VirtTestCase(TestCase, LoaderModuleMockMixin):
         self.mock_conn.storagePoolLookupByName = MagicMock(return_value=mocked_pool)
         self.mock_conn.storagePoolDefineXML = MagicMock()
 
-        self.assertTrue(
-            virt.pool_update('default',
-                             'rbd',
-                             source_name='iscsi-images',
-                             source_hosts=['ses4.tf.local', 'ses5.tf.local'],
-                             source_auth={'username': 'libvirt',
-                                          'password': 'c2VjcmV0'}))
-        self.mock_conn.storagePoolDefineXML.assert_called_once_with(expected_xml)
-        mock_secret.setValue.assert_called_once_with(b'secret')
+        self.assertFalse(
+            virt.pool_update(
+                "default",
+                "rbd",
+                source_name="iscsi-images",
+                source_hosts=["ses4.tf.local", "ses5.tf.local"],
+                source_auth={"username": "libvirt", "password": "c2VjcmV0"},
+            )
+        )
+        self.mock_conn.storagePoolDefineXML.assert_not_called()
+        mock_secret.setValue.assert_called_once_with(b"secret")
 
     def test_pool_update_password_create(self):
-        '''
+        """
         Test the pool_update function, where the password only is changed
-        '''
-        current_xml = '''<pool type='rbd'>
+        """
+        current_xml = """<pool type='rbd'>
           <name>default</name>
           <uuid>20fbe05c-ab40-418a-9afa-136d512f0ede</uuid>
           <capacity unit='bytes'>1999421108224</capacity>
@@ -3188,23 +4624,25 @@ class VirtTestCase(TestCase, LoaderModuleMockMixin):
             <host name='ses4.tf.local'/>
             <host name='ses5.tf.local'/>
           </source>
-        </pool>'''
-
-        expected_xml = '<pool type="rbd">' \
-                       '<name>default</name>' \
-                         '<uuid>20fbe05c-ab40-418a-9afa-136d512f0ede</uuid>' \
-                         '<capacity unit="bytes">1999421108224</capacity>' \
-                         '<allocation unit="bytes">713207042048</allocation>' \
-                         '<available unit="bytes">1286214066176</available>' \
-                         '<source>' \
-                           '<host name="ses4.tf.local" />' \
-                           '<host name="ses5.tf.local" />' \
-                           '<auth type="ceph" username="libvirt">' \
-                             '<secret usage="pool_default" />' \
-                           '</auth>' \
-                           '<name>iscsi-images</name>' \
-                         '</source>' \
-                       '</pool>'
+        </pool>"""
+
+        expected_xml = (
+            '<pool type="rbd">'
+            "<name>default</name>"
+            "<uuid>20fbe05c-ab40-418a-9afa-136d512f0ede</uuid>"
+            '<capacity unit="bytes">1999421108224</capacity>'
+            '<allocation unit="bytes">713207042048</allocation>'
+            '<available unit="bytes">1286214066176</available>'
+            "<source>"
+            '<host name="ses4.tf.local" />'
+            '<host name="ses5.tf.local" />'
+            '<auth type="ceph" username="libvirt">'
+            '<secret usage="pool_default" />'
+            "</auth>"
+            "<name>iscsi-images</name>"
+            "</source>"
+            "</pool>"
+        )
 
         mock_secret = MagicMock()
         self.mock_conn.secretDefineXML = MagicMock(return_value=mock_secret)
